<?php
require_once $_SERVER['DOCUMENT_ROOT'] . '/vendor/autoload.php';

use SevenEcks\Tableify\Tableify;

// Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, 'https://www.bestchange.ru/action.php');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, "action=getrates&page=rates&from=10&to=42&city=0&type=&give=&get=&commission=0&range=desc&sortm=1&tsid=0");
curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');

$headers = array();
$headers[] = 'Authority: www.bestchange.ru';
$headers[] = 'Accept: */*';
$headers[] = 'Accept-Language: en-US,en;q=0.9,ru-RU;q=0.8,ru;q=0.7';
$headers[] = 'Content-Type: application/x-www-form-urlencoded; charset=UTF-8';
$headers[] = 'Cookie: PHPSESSID=i3chg7qvjbqfqjcllgn9a944s3; userid=74afe3f92d35c73f2089400b26f802ef; source=^%^09E^%^95^%^94^%^27^%^B36^%^7C^%^B3^%^88^%^88^%^00^%^13^%^9E^%^EBB^%^91v^%^12C^%^94^%^FD^%^7B^%^7E^%^DA^%^CF^%^FB^%^22t^%^7Ef^%^0C^%^A2^%^8B^%^7D^%^17b5^%^E4^%^82^%^E5b^%^E2V^%^DAA^%^7F^%^C5^%^DD^%^D7xq^%^16; pixel=1; _ga=GA1.2.95409652.1653496837; _gid=GA1.2.452744182.1653496837; _ym_uid=1653496838705961030; _ym_d=1653496838; _ym_isad=1';
$headers[] = 'Origin: https://www.bestchange.ru';
$headers[] = 'Referer: https://www.bestchange.ru/tether-trc20-to-sberbank.html';
$headers[] = 'Sec-Ch-Ua: ^^';
$headers[] = 'Sec-Ch-Ua-Mobile: ?0';
$headers[] = 'Sec-Ch-Ua-Platform: ^^Windows^^\"\"';
$headers[] = 'Sec-Fetch-Dest: empty';
$headers[] = 'Sec-Fetch-Mode: cors';
$headers[] = 'Sec-Fetch-Site: same-origin';
$headers[] = 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/101.0.0.0 Safari/537.36';
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);

$result = mb_convert_encoding($result, 'HTML-ENTITIES', 'utf-8');
echo $result;

$dom = new domDocument;

libxml_use_internal_errors(true);
@$dom->loadHTML($result);
$dom->preserveWhiteSpace = false;
$tbody = $dom->getElementsByTagName('tr');

$array = [['Company', 'Price']];

foreach ($tbody as $row_key => $row) {
    $cols = $row->getElementsByTagName('td');

    if (count($cols) < 9) {
        continue;
    }

    $array[$row_key] = [
        mb_substr(preg_replace("/[^A-Za-z0-9]/", '', $cols[1]->nodeValue), 0, 15),
        preg_replace("/[^.0-9]/", '', $cols[3]->nodeValue)
    ];
}

$message = "Курсы USDT to RUB (сбербанк)\n bestchange.ru\n";

$data = array_slice($array, 0, 20);

echo '<pre>';
print_r($data);
echo '</pre>';

$table = Tableify::new($data);
$table = $table->make();
$table_data = $table->toArray();

$tableMessage = "";
foreach ($table_data as $row) {
    $tableMessage .= $row . "\n";
}

$message .= "<pre>" . $tableMessage . "</pre>";
$message .= "\nhttps://www.bestchange.ru/tether-trc20-to-sberbank.html";

$message = mb_convert_encoding($message, 'HTML-ENTITIES', 'utf-8');

$ch = curl_init();
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
    "Content-Type:multipart/form-data"
));
curl_setopt($ch, CURLOPT_URL, 'https://api.telegram.org/bot5448429020:AAFRJ_z3kce6Mh6Q_NrEQFC6sreOuMO7X9Q/sendMessage');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, ['chat_id' => '5498313873', 'parse_mode' => 'HTML', 'text' => $message]);
$response = curl_exec($ch);

echo '<pre>';
print_r($response);
echo '</pre>';

// 270101094 Evgeniy

// 5498313873 Oleg

// -1001649707296 Group

// 5448429020:AAFRJ_z3kce6Mh6Q_NrEQFC6sreOuMO7X9Q rndx2_bot

// 857507819:AAGmBkQGi6qBNUjwPSxKx5kIktmXIYbsmuM incuo_bot